unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Switches;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    cgMiscOptions: TCheckGroup;
    gbTestSwitch: TGroupBox;
    ImageList1: TImageList;
    RadioGroup1: TRadioGroup;
    cgAnimation: TCheckGroup;
    rgBorderStyle: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure cgAnimationItemClick(Sender: TObject; Index: integer);
    procedure cgMiscOptionsItemClick(Sender: TObject; Index: integer);
    procedure FormCreate(Sender: TObject);
    procedure OnOffSwitch1Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure rgBorderStyleClick(Sender: TObject);
  private
    OnOffSwitch1: TOnOffSwitch;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  OnOffSwitch1 := TOnOffSwitch.Create(self);
  OnOffSwitch1.Parent := gbTestSwitch;
  OnOffSwitch1.Left := 16;
  OnOffSwitch1.Top := 8;
  OnOffSwitch1.ColorOFF := 7697919;
  OnOffSwitch1.OnChange := @OnOffSwitch1Change;
  OnOffSwitch1.Animated := true;
  OnOffSwitch1.AnimationEffects := [saeBlendColors, saeBlendImages, saeRotateImages];
  OnOffSwitch1.Images := ImageList1;
  OnOffSwitch1.ImageIndexON := 1;
  OnOffSwitch1.ImageIndexOFF := 0;
  OnOffSwitch1.SwitchMode := smClick;
  OnOffSwitch1.ShowButtonBorder := false;
  OnOffSwitch1.FlippedColors := true;

  cgAnimation.Checked[0] := saeBlendColors in OnOffSwitch1.AnimationEffects;
  cgAnimation.Checked[1] := saeBlendImages in OnOffSwitch1.AnimationEffects;
  cgAnimation.Checked[2] := saeRotateImages in OnOffSwitch1.AnimationEffects;
  cgAnimation.ChildSizing.TopBottomSpacing := 0;

  cgMiscOptions.Checked[0] := OnOffSwitch1.Animated;
  cgMiscOptions.Checked[1] := OnOffSwitch1.Inverse;
  cgMiscOptions.Checked[2] := OnOffSwitch1.FlippedColors;
  cgMiscOptions.Checked[3] := OnOffSwitch1.Orientation = soVertical;
  cgMiscOptions.Checked[4] := OnOffSwitch1.ShowButtonBorder;
  cgMiscOptions.ChildSizing.TopBottomSpacing := 0;

  if OnOffSwitch1.FlippedColors then
    OnOffSwitch1.Font.Color := clWhite
  else
    OnOffSwitch1.Font.Color := clBlack;

  OnOffSwitch1Change(nil);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OnOffSwitch1.Checked := not OnOffSwitch1.Checked;
end;

procedure TForm1.cgAnimationItemClick(Sender: TObject; Index: integer);
var
  anim: TSwitchAnimationEffects;
begin
  anim := [];
  if cgAnimation.Checked[0] then
    Include(anim, saeBlendColors);
  if cgAnimation.Checked[1] then
    Include(anim, saeBlendImages);
  if cgAnimation.Checked[2] then
    Include(anim, saeRotateImages);
  OnOffSwitch1.AnimationEffects := anim;
end;

procedure TForm1.cgMiscOptionsItemClick(Sender: TObject; Index: integer);
begin
  case Index of
    0: OnOffSwitch1.Animated := cgMiscOptions.Checked[Index];
    1: OnOffSwitch1.Inverse := cgMiscOptions.Checked[Index];
    2: OnOffSwitch1.FlippedColors := cgMiscOptions.Checked[Index];
    3: with OnOffSwitch1 do SetBounds(Left, Top, Height, Width);
    4: OnOffSwitch1.ShowButtonBorder := cgMiscOptions.Checked[Index];
  end;
  if OnOffSwitch1.FlippedColors then
    OnOffSwitch1.Font.Color := clWhite
  else
    OnOffSwitch1.Font.Color := clBlack;
end;

procedure TForm1.OnOffSwitch1Change(Sender: TObject);
begin
  gbTestSwitch.Caption := 'OnOff Switch: Checked=' + BoolToStr(OnOffSwitch1.Checked, true);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  OnOffSwitch1.SwitchMode := TSwitchMode(RadioGroup1.ItemIndex);
end;

procedure TForm1.rgBorderStyleClick(Sender: TObject);
begin
  OnOffSwitch1.BorderStyle := TSwitchBorderStyle(rgBorderStyle.ItemIndex);
end;

end.

